## ros-melodic-async-web-server-cpp 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)
project(async_web_server_cpp VERSION 1.0.3 LANGUAGES CXX)

## Find catkin macros and libraries
find_package(catkin REQUIRED)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS filesystem regex thread)
find_package(OpenSSL REQUIRED)

if(CATKIN_ENABLE_TESTING)
    find_package(catkin REQUIRED COMPONENTS roslib rospy)
    find_package(rostest REQUIRED)
endif()

###################################################
## Declare things to be passed to other projects ##
###################################################

catkin_package(
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME}
    DEPENDS Boost
)

###########
## Build ##
###########

add_library(${PROJECT_NAME}
    src/http_connection.cpp
    src/http_reply.cpp
    src/http_request.cpp
    src/http_request_handler.cpp
    src/http_request_parser.cpp
    src/http_server.cpp
    src/websocket_connection.cpp
    src/websocket_message.cpp
    src/websocket_request_handler.cpp
)

target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
)

target_link_libraries(${PROJECT_NAME}
    PUBLIC
        Boost::boost Boost::filesystem Boost::thread
    PRIVATE
        Boost::regex
        OpenSSL::Crypto
)

target_compile_definitions(${PROJECT_NAME}
    PUBLIC
        $<$<CXX_COMPILER_ID:MSVC>:-D_WIN32_WINNT=0x0A00>
)
target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_11)

###########
# Testing #
###########

if(CATKIN_ENABLE_TESTING)
    add_subdirectory(test)
endif()

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
    FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h"
)

=== test/CMakeLists.txt ===
add_executable(test_web_server EXCLUDE_FROM_ALL test_web_server.cpp)
target_link_libraries(test_web_server PRIVATE ${PROJECT_NAME} ${catkin_LIBRARIES})
target_include_directories(test_web_server PRIVATE ${catkin_INCLUDE_DIRS})

if(TARGET tests)
    add_dependencies(tests
        test_web_server
    )
endif()

add_rostest(tests.test)

## ros-melodic-async-web-server-cpp 0.0.3

=== debian/changelog ===
ros-melodic-async-web-server-cpp (0.0.3-0stretch) stretch; urgency=high

  * Merge pull request #6 from mitchellwills/develop
    Added some tests
  * Added filesystem tests
  * Added some more tests (including websocket tests)
  * Added some more http tests
  * Added an echo test and enabled tests on travis
  * Began working on some tests
  * Fixed missing boost dep
  * Merge pull request #5 from mitchellwills/develop
    Some more improvements
  * Added filesystem request handler
    This serves both files from a given root and directory listings (if requested)
  * Modified request handler signature so that it can reject requests (causing them to be pushed to the next handler in a handler group)
  * Now load a file to be served each time it is requested
  * Fix HTTP Server stop to allow it to be safe to call multiple times
  * Merge pull request #4 from mitchellwills/develop
    A few small improvements
  * Allow for a server to be created even if the system has no non-local IP
    See http://stackoverflow.com/questions/5971242/how-does-boost-asios-hostname-resolution-work-on-linux-is-it-possible-to-use-n
  * Changed write resource to be a const shared ptr
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Tue, 18 Aug 2015 07:00:00 -0000

ros-melodic-async-web-server-cpp (0.0.2-0stretch) stretch; urgency=high

  * Merge pull request #3 from mitchellwills/develop
    Added support for specifying additional headers when creating static request handlers
  * Added some comments to the HTTP reply methods
  * Added support for specifying additional headers when creating static request handlers
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Tue, 06 Jan 2015 08:00:00 -0000

ros-melodic-async-web-server-cpp (0.0.1-0stretch) stretch; urgency=high

  * OCD clenup
  * Merge pull request #2 from mitchellwills/develop
    Few small fixes
  * Fixed message processing so close message is actually passed through
  * Fixed potential memory leak from boost shared_ptr misuse
  * Merge pull request #1 from mitchellwills/develop
    Import of initial implementation from webrtc_ros repo
  * Fixed install directives
  * Added some documentation
  * Added more metadata files
  * Cleaned up file formatting
  * Fixed compilation error on 12.04
  * Added boost dependancy
  * Added travis configuration
  * Package cleanup
  * renamed package to async_web_server_cpp
  * Initial import of cpp_web_server from webrtc_ros
  * Initial commit
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Tue, 02 Dec 2014 08:00:00 -0000

=== debian/control ===
Source: ros-melodic-async-web-server-cpp
Section: misc
Priority: extra
Maintainer: Russell Toris <rctoris@wpi.edu>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libssl-dev, ros-melodic-catkin, ros-melodic-roslib, ros-melodic-rospy, ros-melodic-rostest
Homepage: http://ros.org/wiki/async_web_server_cpp
Standards-Version: 3.9.2

Package: ros-melodic-async-web-server-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libssl-dev, python-websocket
Description: Asynchronous Web/WebSocket Server in C++

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-async-web-server-cpp//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-async-web-server-cpp 1.0.3

=== debian/changelog ===
ros-melodic-async-web-server-cpp (1.0.3-1bionic) bionic; urgency=high

  * Add Windows 10 compatibility (#1 <https://github.com/fkie/async_web_server_cpp/issues/1>)
  * Contributors: Pranav Dhulipala, Timo Röhling

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Fri, 12 Feb 2021 23:00:00 -0000

ros-melodic-async-web-server-cpp (1.0.2-1bionic) bionic; urgency=high

  * Fix integer comparisons
  * Use HTTP/1.1 reply for WebSockets protocol upgrade
  * Contributors: Timo Röhling

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Mon, 11 Jan 2021 23:00:00 -0000

ros-melodic-async-web-server-cpp (1.0.1-1bionic) bionic; urgency=high

  * New maintainer: Timo Röhling
  * Merge outstanding pull requests
    GT-RAIL#14: Fix compatibility issue with Apache2 websocket proxy
    GT-RAIL#16: Fix C++ include path for unit tests (obsolete)
    GT-RAIL#19: Fix Python 3 compatibility for unit tests
  * Modernize CMakeLists.txt
  * Auto-detect MIME types from file extensions

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Mon, 11 Jan 2021 23:00:00 -0000

ros-melodic-async-web-server-cpp (0.0.3-1bionic) bionic; urgency=high

  * Merge pull request #6 from mitchellwills/develop
    Added some tests
  * Added filesystem tests
  * Added some more tests (including websocket tests)
  * Added some more http tests
  * Added an echo test and enabled tests on travis
  * Began working on some tests
  * Fixed missing boost dep
  * Merge pull request #5 from mitchellwills/develop
    Some more improvements
  * Added filesystem request handler
    This serves both files from a given root and directory listings (if requested)
  * Modified request handler signature so that it can reject requests (causing them to be pushed to the next handler in a handler group)
  * Now load a file to be served each time it is requested
  * Fix HTTP Server stop to allow it to be safe to call multiple times
  * Merge pull request #4 from mitchellwills/develop
    A few small improvements
  * Allow for a server to be created even if the system has no non-local IP
    See http://stackoverflow.com/questions/5971242/how-does-boost-asios-hostname-resolution-work-on-linux-is-it-possible-to-use-n
  * Changed write resource to be a const shared ptr
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Mon, 17 Aug 2015 22:00:00 -0000

ros-melodic-async-web-server-cpp (0.0.2-1bionic) bionic; urgency=high

  * Merge pull request #3 from mitchellwills/develop
    Added support for specifying additional headers when creating static request handlers
  * Added some comments to the HTTP reply methods
  * Added support for specifying additional headers when creating static request handlers
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Mon, 05 Jan 2015 23:00:00 -0000

ros-melodic-async-web-server-cpp (0.0.1-1bionic) bionic; urgency=high

  * OCD clenup
  * Merge pull request #2 from mitchellwills/develop
    Few small fixes
  * Fixed message processing so close message is actually passed through
  * Fixed potential memory leak from boost shared_ptr misuse
  * Merge pull request #1 from mitchellwills/develop
    Import of initial implementation from webrtc_ros repo
  * Fixed install directives
  * Added some documentation
  * Added more metadata files
  * Cleaned up file formatting
  * Fixed compilation error on 12.04
  * Added boost dependancy
  * Added travis configuration
  * Package cleanup
  * renamed package to async_web_server_cpp
  * Initial import of cpp_web_server from webrtc_ros
  * Initial commit
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Mon, 01 Dec 2014 23:00:00 -0000

=== debian/control ===
Source: ros-melodic-async-web-server-cpp
Section: misc
Priority: optional
Maintainer: Timo Röhling <timo.roehling@fkie.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libssl-dev, python-websocket, ros-melodic-catkin, ros-melodic-roslib, ros-melodic-rospy, ros-melodic-rostest
Homepage: http://ros.org/wiki/async_web_server_cpp
Standards-Version: 3.9.2

Package: ros-melodic-async-web-server-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev
Description: Asynchronous Web/WebSocket Server in C++
